using System;
using System.Reflection;

using Celeste.Mod;


namespace Bitsbolts {
  [AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
  internal class OnLoad : Attribute {}

  [AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
  internal class OnLoadContent : Attribute {}

  [AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
  internal class OnUnload : Attribute {}

  [AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
  internal class OnInitialize : Attribute {}

  // Thank you Frost Helper my beloved
  internal static class Attributes {
    internal static void DispatchAttr(Type dispatchAttr, params object[] args) {
      foreach (var type in typeof(Attributes).Assembly.GetTypesSafe()) {
        foreach (var method in type.GetMethods(BindingFlags.Static | BindingFlags.NonPublic | BindingFlags.Public)) {
          foreach (var attr in method.CustomAttributes) {
            if (attr.AttributeType == dispatchAttr) {
              method.Invoke(null, args);
              break;
            }
          }
        }
      }
    }
  }
}
